import { EqualityChecker, GetState, SetState, State, StateListener, StateSelector, StateSliceListener, StoreApi, Subscribe } from '../vanilla';
export declare type StoreApiWithSubscribeWithSelector<T extends State> = StoreApi<T> & {
    subscribe: Subscribe<T> & {
        (listener: StateListener<T>): () => void;
        <StateSlice>(selector: StateSelector<T, StateSlice>, listener: StateSliceListener<StateSlice>, options?: {
            equalityFn?: EqualityChecker<StateSlice>;
            fireImmediately?: boolean;
        }): () => void;
    };
};
export declare const subscribeWithSelector: <S extends object, CustomSetState extends SetState<S>, CustomGetState extends GetState<S>, CustomStoreApi extends StoreApi<S>>(fn: (set: CustomSetState, get: CustomGetState, api: CustomStoreApi) => S) => (set: CustomSetState, get: CustomGetState, api: CustomStoreApi & StoreApi<S> & {
    subscribe: Subscribe<S> & {
        (listener: StateListener<S>): () => void;
        <StateSlice>(selector: StateSelector<S, StateSlice>, listener: StateSliceListener<StateSlice>, options?: {
            equalityFn?: EqualityChecker<StateSlice> | undefined;
            fireImmediately?: boolean | undefined;
        } | undefined): () => void;
    };
}) => S;
